registerInputEvent("fxDtsBrick", "onColorChange", "Self fxDTSBrick");
registerOutputEvent("fxDtsBrick", "setSameColor");

function fxDtsBrick::setSameColor(%this)
{
	if($lastInputBrickColor !$= "")
		%this.setColor($lastInputBrickColor);
}

package Event_BrickColor
{
	function fxDtsBrick::onColorChange(%this)
	{
		if(%this.isPlanted)
		{
			$InputTarget_["Self"] = %this;
			%this.processInputEvent("onColorChange");
		}
		return parent::onColorChange(%this);
	}

	function SimObject::processInputEvent(%this, %eventName, %client)
	{
		if(%this.getType() & $TypeMasks::fxBrickAlwaysObjectType)
		{
			$lastInputBrickColor = %this.getColorID();
		}
		return parent::processInputEvent(%this, %eventName, %client);
	}
};
activatePackage(Event_BrickColor);